\chapter{Datastructures}
\label{Ch:Datastructures}


\section{Notes on Generic Types/Templates}
Fortran does not support generic types/templates, which means that if one want to 
implement a procedure that works for more than one type has to find a workaround to this problem.
Among the others, we have a  the \emph{God} abstract class. To redefine the 
methods of an abstract class, allowing to take as actual argument different 
types or number of arguments, it requires to define the interface of the 
overloaded methods. This \emph{interface} is defined in the module containing 
the abstract class. Thus, we will add the interface of all the constructors 

\section{Notes on Creator and Annihilator methods}
Fortran does not support abstract classes in the more general sense of most of 
the OOP languages. In particular, it does not allow to overload the class 
methods of an abstract class if the interface is not declared in the module where original 
abstract class has been declared. Thus, it does not make very much sense to 
enforce the definition of Creator and Annihilator \emph{via} and abstract class, 
as this requires to redefine the module of the original class. Thus, we decided 
to use a ``soft'' approach relying on the good will of MiMiC developers to 
adhere to some fundamental rules, that EACH. class MUST have a 
creator/annihilator:
\begin{itemize}
 \item logical create() 
 \item logical annihilate() 
\end{itemize}

\section{List of derived and extended types}

\noindent\textbf{Map types}
\begin{itemize}

\item type, public :: map\_type
\begin{itemize}
 \item integer :: id
 \item integer :: n\_atoms
 \item integer, dimension(n\_atoms), allocatable :: species\_ids
 \item integer, dimension(n\_atoms), allocatable :: atom\_ids
\end{itemize}

\item type, public :: maps\_type
\begin{itemize}
  \item integer :: n\_codes
  \item type(map\_type), dimension(n\_codes), allocatable :: maps
\end{itemize}

\end{itemize}


\noindent\textbf{Property types}
\begin{itemize}

\item type, abstract :: prop\_type
\begin{itemize}
  \item integer :: id
\end{itemize}
  
\item type, public, extend(prop\_type) :: multipoles\_type
\begin{itemize}
  \item integer :: id
  \item integer, dimension(:), allocatable :: orders
  \item real(dp), dimension(get\_size()), allocatable :: values ! class(*)?
  \item procedure :: get\_size =$>$ get\_size\_multipoles
\end{itemize}

\item type, public, extend(multipoles\_type) :: gaussian\_multipoles\_type
\begin{itemize}
  \item real(dp) :: width
\end{itemize}

\end{itemize}


\noindent\textbf{System types}
\begin{itemize}

\item type, public :: nucleus\_type
\begin{itemize}
  \item integer :: id
  \item integer :: species\_id
  \item integer :: atom\_id
  \item integer :: charge ! pointer?
  \item real(dp) :: mass ! pointer?
  \item real(dp), dimension(3), pointer :: position
  \item real(dp), dimension(3), pointer :: force
\end{itemize}

\item type, public, extend(nucleus\_type) :: atom\_type
\begin{itemize}
  \item integer :: n\_prop
  \item class(prop\_type), dimension(n\_prop), allocatable :: properties()
\end{itemize}

\item type, public :: site\_type ! non-atomic sites
\begin{itemize}
  \item integer :: id
  \item real(dp), dimension(3) :: position
  \item integer :: n\_prop
  \item class(prop\_type), dimension(n\_prop), allocatable :: properties()
  \item procedure :: get\_position()
\end{itemize}

\item type, public :: fragment\_type
\begin{itemize}
  \item integer id
  \item integer n\_atoms
  \item type(atom\_type), dimension(n\_atoms), allocatable :: atoms
\end{itemize}

\item type, public :: quantum\_fragment\_type
\begin{itemize}
  \item integer :: id
  \item integer :: n\_nuclei
  \item type(nucleus\_type), dimension(n\_nuclei), allocatable :: nuclei  
  \item type(electrons\_type) :: electrons
\end{itemize}

\item type, public :: fragments\_type ! one per code
\begin{itemize}
  \item integer :: id
  \item integer :: n\_fragments
  \item character(*) :: tag
  \item real(dp) :: factor
  \item type(fragment\_type), dimension(n\_fragments), allocatable :: fragments
\end{itemize}
 
\item type, public :: field\_grid\_type
\begin{itemize}
  \item integer n\_a, n\_b, n\_c
  \item integer real:: da(3), db(3), dc(3)
  \item class(*), dimension(n\_a, n\_b, n\_c), pointer ::  field
\end{itemize}

\item type, public :: electrons\_type
\begin{itemize}
   \item id
   \item type(field\_grid\_type) :: density
   \item type(field\_grid\_type) :: potential
 \end{itemize}
 
\end{itemize}

